program UpLoad; {Version fr Delphi 3 Standard ohne HTTP-App-Objekte}

{ UpLoad.exe  sollte in /cgi-bin auf dem Webserver liegen}
{ Aufruf des Scripts mit Methode POST vom Formular-Button aus}

{$APPTYPE CONSOLE}

uses Windows, SysUtils, Classes, IniFiles, PostContent;

{ ----Hilfs-Routinen -------------------------------------------------------- }

function GetIniName: String;            // Name der zugeordneten Parameterdatei
begin GetIniName:=ChangeFileExt(Paramstr(0),'.ini') end;

function DeCrypt(const sIn: String): String;                 // Entschlsselung
begin
 { hier bei Bedarf eigenen Entschlsslungscode eintragen                      }
 DeCrypt:=sIn;                                  // z.Z. unverndert zurckgeben
end;

{---- Hauptprogramm ----------------------------------------------------------}

var Ini: TIniFile;                          // Parameterdatei zur Konfiguration
    Liste: TStringList;                  // Ergebnisliste fr Formularfeldwerte
    Templ: TMemoryStream;                            // Puffer fr Antwortseite
    sResult, sTempDir, sUserDir, sFile, sUser, sAnswer, sMsg: String;
    nP: Integer;
    cBuf: array[0..254] of Char;
begin
 Ini:=TIniFile.Create(GetIniName);
 sTempDir:=Ini.ReadString('Settings','TempDir','');   // temporres Verzeichnis
 sAnswer:= Ini.ReadString('Settings','Answer',''); // Vorlage fr Ergebnisseite
 Ini.Free;
 if sTempDir='' then begin                    // nichts in INI-Datei vorgegeben
  FillChar(cBuf,SizeOf(cBuf),#0);
  if GetEnvironmentVariable('TEMP',cBuf,SizeOf(cBuf))>1 then sTempDir:=cBuf
  else if GetEnvironmentVariable('TMP',cBuf,SizeOf(cBuf))>1 then sTempDir:=cBuf;
 end;      // wenn nichts angegeben, wird halt das aktuelle Verzeichnis benutzt
 if sTempDir<>'' then if sTempDir[Length(sTempDir)]<>'\' then sTempDir:=sTempDir+'\';
 sTempDir:=sTempDir+IntToStr(Abs(GetCurrentThreadID))+'\';
 try MkDir(sTempDir) except end;
 Liste:=TStringList.Create;                 // Pufferspeicher fr Formulardaten
 if GetPostedContent(Liste,sTempDir) then begin  // gePOSTete Daten aufgenommen
  sFile:=ExtractFileName(Liste.Values['upfile']);// Dateiname aus Formulardaten
  if sFile<>'' then begin
   sUser:=Liste.Values['user'];
   if sUser<>'' then begin             // Username ist ins Formular eingetragen
    Ini:=TIniFile.Create(GetIniName);
    sResult:=DeCrypt(Ini.ReadString(sUser,'Pass','@')); // Passwort aus der Datenbank
    sUserDir:=Ini.ReadString(sUser,'UserDir','');     // privates Speicherverzeichnis
    Ini.Free;
    if sResult=Liste.Values['pass'] then begin // mit Passwort aus Formular vergleichen
     if (sUserDir<>'') then begin    // privates Speicherverzeichnis ist gltig
      if sUserDir[Length(sUserDir)]<>'\' then sUserDir:=sUserDir+'\';
      Templ:=TMemoryStream.Create;
      try                                      // hochgeladene Datei umkopieren
       Templ.LoadFromFile(sTempDir+sFile); Templ.SaveToFile(sUserDir+sFile);
       sMsg:=Format('Die Datei <B>%s</B> von %s wurde im privaten Web-Verzeichnis abgelegt.',[sFile,sUser]);
      except sMsg:=Format('Die Datei <B>%s</B> von %s konnte <B>nicht</B> ordnungsgem&auml;&szlig; gespeichert werden.',[sFile,sUser]) end;
      Templ.Free;
     end else sMsg:=Format('Ihr privates UpLoad-Verzeichnis ist <B>nicht</B> korrekt eingerichtet.',[sFile,sUser]);
    end else sMsg:='Das angegebene Benutzerpasswort ist <B>nicht</B> korrekt.';
   end else sMsg:='Es wurde <B>kein</B> Benutzername in das Formular eingetragen.';
   try DeleteFile(sTempDir+sFile) except end; // evt. hochgeladene Datei aus TEMP lschen
  end else sMsg:='Es wurde <B>keine</B> Datei zum Hochladen in das Formular eingetragen';
 end else sMsg:='Sie benutzen <B>nicht</B> das richtige Formular.';
 Liste.Free;
 try RmDir(sTempDir) except end;  // leeres Unterverzeichnis von TEMP lschen
 Templ:=TMemoryStream.Create();                      // Puffer fr Antwortseite
 try
  if sAnswer='' then sAnswer:=ChangeFileExt(GetIniName,'.htm');
  Templ.LoadFromFile(sAnswer);              // Master-Temolate der Antwortseite
  SetString(sResult,PChar(Templ.Memory),Templ.Size);
 except                 // falls nicht zu finden: Notreserven direkt generieren
  sResult:='<HTML><HEAD><TITLE>Ergebnis</TITLE></HEAD><BODY><H1>Ergebnis</H1><HR><#msg><HR><SMALL><#date>, <#time></SMALL></BODY></HTML>'#13#10;
 end;
 Templ.Free;
 nP:=Pos('#date>',sResult); if nP>0 then begin Dec(nP); Delete(sResult,nP,7); Insert(FormatDateTime('yy-mm-dd',Now),sResult,nP) end;
 nP:=Pos('#time>',sResult); if nP>0 then begin Dec(nP); Delete(sResult,nP,7); Insert(FormatDateTime('hh:nn:ss',Now),sResult,nP) end;
 nP:=Pos('#msg>' ,sResult); if nP>0 then begin Dec(nP); Delete(sResult,nP,6); Insert(sMsg,sResult,nP) end;
 WriteLn(Output,'Content-type: text/html');
 WriteLn;
 WriteLn(Output,sResult);
end.

